#!/usr/bin/perl
#
# Webview by Uli Eckhardt, October 1997.
#
# I have written a perl script which displays faxes via the web and allows
# users to delete faxes (all users which have access to this page). It 
# requires a running web server on the fax-host and RecvFileMode should be
# set to 0666. 

# In the webview.tar.gz there is show.pl which is this script; with a couple
# of gif images. Put show.pl in your cgi-bi directory and the images in the
# directory 'docroot'/graphics. Please check the first few lines of the script,
# because paths to tiffcp and the png-programs may differ.
#

$TIFFCP = "/usr/local/bin/tiffcp -c none";
$TIFFPS = "/usr/local/bin/tiff2ps -ap ";
$FAXINFO = "/usr/local/sbin/faxinfo";
$FAXSTAT = "/usr/local/bin/faxstat -s -a";
$FAXROOT = "/var/spool/fax";
$GRAPHICS = "/graphics";
$PNG = "/usr/X11R6/bin";
$PRINTCMD = "/usr/local/bin/lpr -Praw";
$HOST="klausi";
$PORT=4559;
$BASE="/cgi-bin/show.pl";

sub html_header {
        local($title) = @_;
        print "Content-type: text/html\n\n";
        print "<HTML><HEAD><TITLE>$title</TITLE></HEAD><BODY>\n";
        print "<IMG ALIGN=CENTER SRC=\"/graphics/fax.gif\">\n";
        print "<FONT SIZE=6>$title</FONT><BR>\n";
}

sub html_tail {
        print "</BODY></HTML>\n";
}

sub getparam {
        if ($ENV{'REQUEST_METHOD'} eq "POST") {
                read(STDIN, $ENV{'QUERY_STRING'},$ENV{'CONTENT_LENGTH'});
        }

        foreach (split(/&/, $ENV{'QUERY_STRING'})) {
                $value = "";
                ($key, $value) = split(/=/);
                if ($value != "") {
                        $value =~ s/\+/ /g;
                        $value =~ s/%([0-9A-F]{2})/pack('C', hex($1))/eig;
                        if ($value !~ /^[a-zA-Z0-9_\-+\. \t\/@%]+$/) {
                                html_header("Error");
                                print "<BR>Illegal character in input<BR>";
                                html_tail;
                                exit(1);
                        }
                }
                $form{$key} = $value;
        }
}

sub makeline {
	local($file, $mode, $check) = @_;
	local($line, $sender, $pages, $received, $dataformat);
	$faxfile = "$FAXROOT/recvq/$file";
	open(FINFO,"$FAXINFO -n $faxfile |");
	while(<FINFO>) {
		if ($_ =~ /\s*(\w*): (.*)/) {
                	switch: {
                        	($1 eq "Sender") && ($sender = $2, last switch);
                        	($1 eq "Pages")  && ($pages = $2, last switch);
                        	($1 eq "Received") && ($received = $2, last switch);
                                ($1 eq "DataFormat") && ($dataformat = $2, last switch);
                        }
                }
	}
	close FINFO;
	print "<TR>\n";
	if ($mode == 1) {
		print "<TD><INPUT Type=\"radio\" Name=\"file\" Value=\"$file\" $check> ";
	}
	else {
		print "<TD>";
	}
	print "$sender</TD><TD>$pages</TD><TD>$received</TD><TD>$dataformat</TD>\n";
	if ($mode == 1) {
		print "<TD><A HREF=\"ftp://$HOST:$PORT/recvq/$file\"><IMG BORDER=0 SRC=\"/graphics/copy.gif\"></A></TD>";
	}
	print "</TR>\n";
}

sub status
{
	html_header("Fax status");

	print "<PRE>\n";
	open(DATA,"$FAXSTAT 2>/dev/null |");
	while(<DATA>) {
		print $_;
	}
	close DATA;
	print "</PRE>\n<HR>\n";

	opendir(recdir,"$FAXROOT/recvq");
	@allfiles = grep(/fax[0-9]*.tif/,readdir(recdir));
	closedir(recdir);
	
	print "<FORM Method=\"GET\" Action=\"/cgi-bin/show.pl\">\n";
	print "<P>\n";
	print "<INPUT Type=\"radio\" Name=\"size\" Value=\"400\">Small\n";
	print "<INPUT Type=\"radio\" Name=\"size\" Value=\"640\" CHECKED>Med\n";
	print "<INPUT Type=\"radio\" Name=\"size\" Value=\"800\">Large\n";
	print "</P>\n";
	
	print "<TABLE BORDER=0>\n";
	print "<TR>\n";
	print "<TD>Sender</TD><TD>Pages</TD><TD>Received</TD><TD>Data Format</TD><TD></TD>";
	print "</TR>\n";
	$check = "CHECKED";
	for (@allfiles) {
		makeline($_,1,$check);
		$check = "";
	}
	print "</TABLE>\n";
	print "<BR><HR><P>\n";
	print "<INPUT Type=\"submit\" Name=\"mode\" Value=\"View\">\n";
	print "<INPUT Type=\"submit\" Name=\"mode\" Value=\"Print\">\n";
	print "<INPUT Type=\"submit\" Name=\"mode\" Value=\"Delete\">\n";
	print "</P>\n";
	html_tail;
}

sub view
{
	$faxfile = "$FAXROOT/recvq/$form{'file'}";
	open(FINFO,"$FAXINFO -n $faxfile |");
	while(<FINFO>) {
		if ($_ =~ /\s*(\w*): (.*)/) {
                	switch: {
                        	($1 eq "Sender") && ($sender = $2, last switch);
                        	($1 eq "Pages")  && ($pages = $2, last switch);
                        	($1 eq "Received") && ($received = $2, last switch);
                                ($1 eq "DataFormat") && ($dataformat = $2, last switch);
                        }
                }
                else { 
                	print "sytax error on line $line\n";
                }
	}
	close FINFO;
	$file = $form{'file'};
	html_header("Fax from $sender received $received");
	for ($i = 0; $i < $pages; $i++) {
		print "<p>Page ",$i+1,"</p>\n"; 
		print "<IMG SRC=\"/cgi-bin/show.pl?mode=gif&file=$file&size=$form{'size'}&page=$i\">\n";
		print "<BR><HR>\n";
        }
	print "<A HREF=\"/cgi-bin/show.pl?mode=Print&file=$file\"><IMG BORDER=0 SRC=/graphics/print.gif WIDTH=59 HEIGHT=19></A>\n";
	html_tail;
}

sub gifpic
{
	$tmpfile = "/tmp/view$$.tif";
	local ($selfh) = select(STDOUT);
	$| =1;
	select($selfh);
	$file = "$FAXROOT/recvq/$form{'file'}";
	$pg = $form{'page'};
	open(FINFO,"$FAXINFO -n $file |");
	while(<FINFO>) {
		if ($_ =~ /\s*(\w*): (.*)/) {
                	switch: {
                        	($1 eq "Quality") && ($q = $2, last switch);
                        }
                }
                else { 
                	print "sytax error on line $line\n";
                }
	}
	close FINFO;

	system("$TIFFCP $file $tmpfile 2>/dev/null");	
	system("$TIFFPS -d $pg $tmpfile >$tmpfile.ps 2>/dev/null");
	$width = $form{'size'};
	print "Content-type: image/gif\n\n";
#	if ($q eq "Normal") {
#		system("gs -q -dNOPAUSE -sDEVICE=pnm -sOutputFile=$tmpfile.2  $tmpfile.ps -c quit 2>/dev/null");
#		system("$PNG/pnmscale -width $width $tmpfile.2 2>/dev/null | $PNG/pnmscale -yscale 2 | $PNG/pnmdepth 31 | $PNG/ppmtogif 2>/dev/null");
#	}
#	else {
		system("gs -q -dNOPAUSE -sDEVICE=pnm -sOutputFile=$tmpfile.2  $tmpfile.ps -c quit 2>/dev/null");
		system("$PNG/pnmscale -width $width $tmpfile.2 2>/dev/null | $PNG/pnmdepth 31 | $PNG/ppmtogif 2>/dev/null");
#	}
	unlink($tmpfile);
	unlink("$tmpfile.ps");
	unlink("$tmpfile.2");
}

sub pr
{
	$faxfile = "$FAXROOT/recvq/$form{'file'}";
	open(FINFO,"$FAXINFO -n $faxfile |");
	while(<FINFO>) {
		if ($_ =~ /\s*(\w*): (.*)/) {
                	switch: {
                        	($1 eq "Sender") && ($sender = $2, last switch);
                        	($1 eq "Pages")  && ($pages = $2, last switch);
                        	($1 eq "Received") && ($received = $2, last switch);
                                ($1 eq "DataFormat") && ($dataformat = $2, last switch);
                        }
                }
                else { 
                	print "sytax error on line $line\n";
                }
	}
	close FINFO;
	html_header("Printing Fax");
	print "Fax $sender sended to printer<BR>\n";
	system("$TIFFPS $FAXROOT/recvq/$form{'file'} | $PRINTCMD 2>/dev/null >/dev/null");
	html_tail;
}

sub del
{
	system("rm $FAXROOT/recvq/$form{'file'}");
	status();
}

$form{'size'}=640;

getparam();

if ($form{'mode'} eq "") {
	status();
}
if ($form{'mode'} eq "View") {
	view();
}
if ($form{'mode'} eq "gif") {
	gifpic();
}
if ($form{'mode'} eq "Print") {
	pr();
}

if ($form{'mode'} eq "Delete") {
	del();
}
